.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm		; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

ShowCpu	PROTO:DWORD

LOOP_COUNT =	10000000
cyct_subct =	LOOP_COUNT/1000 		; 1000 entries in cyct_table
SleepMs =	50	; Invoke Sleep, SleepMs
CutFast =	20	; # of timings to be cut off on the fast side	
CutSlow =	200	; # of timings to be cut off on the slow side

cyct_begin MACRO
  tmp$ CATSTR <Lc=>, %LOOP_COUNT, <, SubCt=>, %cyct_subct
  % echo tmp$
  if cyct_subct lt 100
  	cyct_subct = 100
  	echo increased to 100
  endif
  and cyct_counter, 0			;; clear the counter
  invoke Sleep, SleepMs
  .Repeat
	counter_begin cyct_subct, HIGH_PRIORITY_CLASS
ENDM
;		mov eax, len(offset Tst50)
cyct_end MACRO arg
LOCAL tmp$
  counter_end
  	mov edx, cyct_counter
  	mov [cyct_table+4*edx], eax
	inc cyct_counter
  .Until edx>=sizeof cyct_table/4
  inc edx
  invoke CombSortA, offset cyct_table, edx
  xor ebx, ebx
  .Repeat
  	print str$(ebx), ":"
	mov eax, [cyct_table+4*ebx]
	if 1
		print str$(eax), " "
	else
		print str$(eax), 9
		tmp$ CATSTR <print " cycles for ">, <, 9, ">, <arg>, <", 13, 10>
		;% echo tmp$
		tmp$
	endif
  	inc ebx
  .Until ebx>CutFast
  print chr$(13, 10, 10, "...", 13, 10, 10)
  mov ebx, cyct_counter
  sub ebx, CutSlow
  .Repeat
  	print str$(ebx), ":"
	mov eax, [cyct_table+4*ebx]
	if 1
		print str$(eax), " "
	else
		print str$(eax), 9
		tmp$ CATSTR <print " cycles for ">, <, 9, ">, <arg>, <", 13, 10>
		;% echo tmp$
		tmp$
	endif
  	inc ebx
  .Until ebx>=cyct_counter
  tmp$ CATSTR <print chr$(13, 10, ">, <arg>, <: subcounter=",9)>
;  % echo tmp$
  tmp$
  print str$(cyct_subct), 13, 10, "average with cutoff", 9
  m2m ebx, CutFast
  xor eax, eax
  mov edx, cyct_counter
  sub edx, CutSlow
  .Repeat
	add eax, [cyct_table+4*ebx]
	inc ebx
  .Until ebx>edx
  sub ebx, CutFast
  cdq
  div ebx
  print str$(eax)

  print chr$(13, 10, "average w/o cutoff ", 9)
  xor eax, eax
  xor ebx, ebx
  mov edx, cyct_counter
  ; sub edx, CutSlow
  .Repeat
	add eax, [cyct_table+4*ebx]
	inc ebx
  .Until ebx>edx
  ; sub ebx, CutFast
  cdq
  div ebx
  print str$(eax)

ENDM

.data?
cyct_counter	dd ?
cyct_table	dd 1000 dup(?)

.data
Tst50	db "This is a string with exactly 50 characters ------", 0

.code
start:
	invoke ShowCpu, 1	; prints the brand string and returns SSE level in eax
	print "Testing timings with cutoff, subcounter="
	print str$(cyct_subct), 13, 10, 10

	MyTest equ <mov eax, len(offset Tst50)>

	cyct_begin
		MyTest		
	cyct_end MyTest

	inkey chr$(13, 10, 10, "*** ok - press any key ***")
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
ShowCpue:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

end start
OPT_WAIT	0
OPT_Tmp2Asm	1
